## netplan.io 0.36.1

=== Makefile ===
BUILDFLAGS = \
	-std=c99 \
	-D_XOPEN_SOURCE=500 \
	-Wall \
	-Werror \
	$(NULL)

SYSTEMD_GENERATOR_DIR=$(shell pkg-config --variable=systemdsystemgeneratordir systemd)
SYSTEMD_UNIT_DIR=$(shell pkg-config --variable=systemdsystemunitdir systemd)
BASH_COMPLETIONS_DIR=$(shell pkg-config --variable=completionsdir bash-completion || echo "/etc/bash_completion.d")

ROOTPREFIX ?= /
PREFIX ?= /usr
ROOTLIBEXECDIR ?= $(ROOTPREFIX)/lib
SBINDIR ?= $(PREFIX)/sbin
DATADIR ?= $(PREFIX)/share
DOCDIR ?= $(DATADIR)/doc
MANDIR ?= $(DATADIR)/man

PYCODE = netplan/ $(wildcard src/*.py) $(wildcard tests/*.py)

# Order: Fedora/Mageia/openSUSE || Debian/Ubuntu || null
PYFLAKES3 ?= $(shell which pyflakes-3 || which pyflakes3 || echo true)
PYCODESTYLE3 ?= $(shell which pycodestyle-3 || which pycodestyle || which pep8 || echo true)

default: generate doc/netplan.5 doc/netplan.html

generate: src/generate.[hc] src/parse.[hc] src/util.[hc] src/networkd.[hc] src/nm.[hc]
	$(CC) $(BUILDFLAGS) $(CFLAGS) -o $@ $(filter %.c, $^) `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`

clean:
	rm -f generate doc/*.html doc/*.[1-9]
	rm -f *.gcda *.gcno generate.info
	rm -rf test-coverage .coverage

check: default linting
	tests/generate.py
	tests/cli.py
	nosetests3 -v --with-coverage

linting:
	$(PYFLAKES3) $(PYCODE)
	$(PYCODESTYLE3) --max-line-length=130 $(PYCODE)

coverage: | pre-coverage c-coverage python-coverage

pre-coverage:
	rm -f .coverage
	$(MAKE) CFLAGS="-g -O0 --coverage" clean check
	mkdir -p test-coverage/C test-coverage/python

check-coverage: coverage
	@if grep headerCovTableEntryHi test-coverage/C/index.html | grep -qv '100.*%'; then \
	    echo "FAIL: Test coverage not 100%!" >&2; exit 1; \
	fi
	python3-coverage report --omit=/usr* --show-missing --fail-under=100

c-coverage:
	lcov --directory . --capture -o generate.info
	lcov --remove generate.info "/usr*" -o generate.info
	genhtml -o test-coverage/C/ -t "generate test coverage" generate.info

python-coverage:
	python3-coverage html -d test-coverage/python --omit=/usr* || true
	python3-coverage xml --omit=/usr* || true

install: default
	mkdir -p $(DESTDIR)/$(SBINDIR) $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR)
	mkdir -p $(DESTDIR)/$(MANDIR)/man5 $(DESTDIR)/$(DOCDIR)/netplan/examples
	mkdir -p $(DESTDIR)/$(DATADIR)/netplan/netplan
	install -m 755 generate $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/
	find netplan/ -name '*.py' -exec install -Dm 644 "{}" "$(DESTDIR)/$(DATADIR)/netplan/{}" \;
	install -m 755 src/netplan.script $(DESTDIR)/$(DATADIR)/netplan/
	ln -sr $(DESTDIR)/$(DATADIR)/netplan/netplan.script $(DESTDIR)/$(SBINDIR)/netplan
	ln -sr $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/generate $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR)/netplan
	install -m 644 doc/*.html $(DESTDIR)/$(DOCDIR)/netplan/
	install -m 644 examples/*.yaml $(DESTDIR)/$(DOCDIR)/netplan/examples/
	install -m 644 doc/*.5 $(DESTDIR)/$(MANDIR)/man5/
	install -D -m 644 src/netplan-wpa@.service $(DESTDIR)/$(SYSTEMD_UNIT_DIR)/netplan-wpa@.service
	install -T -D -m 644 netplan.completions $(DESTDIR)/$(BASH_COMPLETIONS_DIR)/netplan

%.html: %.md
	pandoc -s --toc -o $@ $<

doc/netplan.5: doc/manpage.md doc/netplan.md
	pandoc -s -o $@ $^

.PHONY: clean

=== debian/changelog ===
netplan.io (0.36.1) bionic; urgency=medium

  * tests/integration.py: Do a better cleanup for bridge-based tests; should
    fix instability with test_mix_bridge_on_bond.
  * tests/integration.py: Adjust autopkgtests to account for default behavior
    change for up/down delay, arp interval, mii interval introduced in the
    last upload.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 23 Apr 2018 17:03:11 -0400

netplan.io (0.36) bionic; urgency=medium

  * 'netplan try': properly reset terminal flags at the end of the command,
    so that terminal behaves the same after as before it was run.
    (LP: #1766283)
  * Fix default behavior for unspecified time values in bond parameters: if
    no time-value suffix such as 'ms' is added, consider the value to be in
    milliseconds for MII monitor interval, up/down delay and ARP interval
    so users can have the expected additional granularity when setting up
    these parameters. (LP: #1765833)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 23 Apr 2018 11:38:56 -0400

netplan.io (0.35) bionic; urgency=medium

  * debian/postinst: fix version check for when to write breadcrumbs.
    (LP: #1756742)
  * bonds/bridges: Support specifying time-based values with "ms" suffix when
    the value should be in milliseconds; while keeping support for the previous
    behavior of handling values are pure seconds when no suffix is present.
    (LP: #1745597)
  * IPv6: accept-ra should default to being unset, so that the kernel default
    can be used. (LP: #1732002)
  * DHCPv4: add a "dhcp-identifier: mac" field that can be set to fix interop
    with Windows Server-based DHCP servers which don't support RFC 4361.
    (LP: #1738998)
  * docs, examples: reformat comments in examples, add standalone example files
  * debian/docs, debian/netplan.io.install: install doc and examples in the
    right locations.
  * netplan try: allow users to preview/test and approve network configuration
    changes, and automatically revert if they are not accepted. (LP: #1764824)
  * networkd: don't wipe out /run/netplan on generate: we do want to keep any
    YAML configurations in that directory, we just need to remove generated
    wpasupplicant configs. (LP: #1764869)
  * debian/control: add bash-completion to Build-Depends to make sure we do
    install completion files in the right location.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 17 Apr 2018 21:49:21 -0400

netplan.io (0.34.1) bionic; urgency=medium

  * Makefile: be more distro-agnostic, support different paths for pyflakes,
    pycodestyle, etc.
  * Makefile: allow varying install destinations.
  * Do not attempt to rebind driver 'qeth'. (LP: #1756322)
  * docs/netplan.md: clarify the behavior of 'dhcp6: yes'.
  * docs/netplan.md, docs/manpage.md: rework documentation files to generate
    the manpage with its own headers and other things that don't apply to other
    doc formats such as HTML.
  * migrate: command renamed from ifupdown-migrate, although still disabled.
  * tests: re-instate bridge-priority integration test.
  * Added .spec build rules file for building RPM packages.
  * debian/postinst: reworded "breadcrumbs" written to /etc/network/interfaces.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 22 Mar 2018 15:09:12 -0400

netplan.io (0.34) bionic; urgency=medium

  * New release 0.34 (LP: #1754019):
    * Implement "optional: true" to correctly write systemd network definitions
      with "RequiredForOnline=false", so that these networks do not block boot.
      (LP: #1664844)
    * Implement 'help' as a subcommand of any netplan command, so that running
      'netplan * help' always returns some helpful information. (LP: #1748629)
    * Reinstate snap support for dealing with the NetworkManager snap.
      (LP: #1747714)
    * Added bash completion. (LP: #1749869)
    * Implement 'netplan ip leases': allows users to retrieve lease information
      for the backend in use; to query for custom DHCP options.
    * Don't silently break bridge-priority; fix it instead. (LP: #1752162)
    * Miscellaneous coverage, linting, and fuzzing fixes.
    * Refactor subcommands into separate source files, automate command loading
      and various code cleanups.
    * Disable "ifupdown-migrate"; which is incomplete and thus risks breaking
      systems. Better iterate over it without showing it as a viable option.
    * Add better routing support, implement initial routing policy support.
      - Add 'on-link' support. (LP: #1735193)
  * debian/control:
    - Renamed source and "real" binary to netplan.io.
    - Added a transitional package for nplan.
    - Updated Vcs-* fields to point to the Github project we now use.
    - Updated Standards-Version, debhelper.
  * debian/compat: bump to debhelper compat level 11.
  * debian/copyright: Update Format: field for https.
  * debian/netplan.io.install: obligatory file to install files.
  * debian/source/format: now we're 3.0 native, for reals.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 07 Mar 2018 15:29:45 +0100

nplan (0.33) bionic; urgency=medium

  * replug: Do not unbind ath9kl_sdio. Thanks Oliver! (LP: #1741910)
  * doc: fix syntax for IPv6 example addresses. IPv6 needs to be escaped in
    YAML. (LP: #1735317)
  * debian/postinst: Write breadcrumbs on disk in /etc/network/interfaces to
    denote the migration to using netplan. (LP: #1744968)
  * bridge: implement port-priority support for the NM and networkd backends.
    (LP: #1735821)
  * doc: routes are not top-level but per-interface. (LP: #1726695)
  * Rework CLI parsing / code layout to better handle subcommands.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 23 Jan 2018 11:32:47 -0500

nplan (0.32) bionic; urgency=medium

  * src/nm.c: better handle the UUID generation; the order of iterating
    through interaces may affect things here. Also make sure the tests catch
    a null UUID.



=== debian/control ===
Source: netplan.io
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Section: net
Priority: important
Standards-Version: 4.1.3
Build-Depends: debhelper (>= 11),
 pkg-config,
 bash-completion,
 libyaml-dev,
 libglib2.0-dev,
 uuid-dev,
 python3 (>= 3.1),
 python3-coverage,
 python3-yaml,
 systemd,
 pyflakes3,
 pycodestyle | pep8,
 python3-nose,
 pandoc,
Vcs-Git: https://github.com/CanonicalLtd/netplan
Vcs-Browser: https://github.com/CanonicalLtd/netplan

Package: netplan.io
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
 ${misc:Depends},
 python3,
 python3-yaml,
 systemd (>= 235-3ubuntu3),
Suggests: network-manager | wpasupplicant
Conflicts: netplan
Breaks: nplan (<< 0.34~), network-manager (<< 1.2.2-0ubuntu4~)
Replaces: nplan (<< 0.34~)
Provides: nplan
Description: YAML network configuration abstraction for various backends
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 Currently supported backends are networkd and NetworkManager.

Package: nplan
Architecture: all
Priority: optional
Section: oldlibs
Depends: netplan.io, ${misc:Depends}
Description: YAML network configuration abstraction - transitional package
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 This is a transitional package that installs 'netplan.io'.

=== debian/tests/control ===
Tests: integration.py
Tests-Directory: tests
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: allow-stderr, needs-root, isolation-machine

Tests: autostart
Restrictions: allow-stderr, needs-root, isolation-container

## netplan.io 0.40.1~18.04.4

=== Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 PYFLAKES3 ?= $(shell which pyflakes-3 || which pyflakes3 || echo true)
 PYCODESTYLE3 ?= $(shell which pycodestyle-3 || which pycodestyle || which pep8 || echo true)
 
-default: generate doc/netplan.5 doc/netplan.html
+default: generate doc/netplan.html doc/netplan.5 doc/netplan-generate.8 doc/netplan-apply.8 doc/netplan-try.8
 
 generate: src/generate.[hc] src/parse.[hc] src/util.[hc] src/networkd.[hc] src/nm.[hc]
 	$(CC) $(BUILDFLAGS) $(CFLAGS) -o $@ $(filter %.c, $^) `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
@@ -37,6 +37,7 @@
 	tests/generate.py
 	tests/cli.py
 	nosetests3 -v --with-coverage
+	tests/validate_docs.sh
 
 linting:
 	$(PYFLAKES3) $(PYCODE)
@@ -66,7 +67,8 @@
 
 install: default
 	mkdir -p $(DESTDIR)/$(SBINDIR) $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR)
-	mkdir -p $(DESTDIR)/$(MANDIR)/man5 $(DESTDIR)/$(DOCDIR)/netplan/examples
+	mkdir -p $(DESTDIR)/$(MANDIR)/man5 $(DESTDIR)/$(MANDIR)/man8
+	mkdir -p $(DESTDIR)/$(DOCDIR)/netplan/examples
 	mkdir -p $(DESTDIR)/$(DATADIR)/netplan/netplan
 	install -m 755 generate $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/
 	find netplan/ -name '*.py' -exec install -Dm 644 "{}" "$(DESTDIR)/$(DATADIR)/netplan/{}" \;
@@ -76,13 +78,17 @@
 	install -m 644 doc/*.html $(DESTDIR)/$(DOCDIR)/netplan/
 	install -m 644 examples/*.yaml $(DESTDIR)/$(DOCDIR)/netplan/examples/
 	install -m 644 doc/*.5 $(DESTDIR)/$(MANDIR)/man5/
+	install -m 644 doc/*.8 $(DESTDIR)/$(MANDIR)/man8/
 	install -D -m 644 src/netplan-wpa@.service $(DESTDIR)/$(SYSTEMD_UNIT_DIR)/netplan-wpa@.service
 	install -T -D -m 644 netplan.completions $(DESTDIR)/$(BASH_COMPLETIONS_DIR)/netplan
 
 %.html: %.md
 	pandoc -s --toc -o $@ $<
 
-doc/netplan.5: doc/manpage.md doc/netplan.md
+doc/netplan.5: doc/manpage-header.md doc/netplan.md doc/manpage-footer.md
+	pandoc -s -o $@ $^
+
+%.8: %.md
 	pandoc -s -o $@ $^
 
 .PHONY: clean

=== debian/changelog ===
netplan.io (0.40.1~18.04.4) bionic-security; urgency=medium

  * No change rebuild in -security pocket to fix dependency issue
    (LP: #1811210)

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 10 Jan 2019 12:03:08 -0500

netplan.io (0.40.1~18.04.3) bionic; urgency=medium

  * Fix idempotency in renaming: bond members should be exempt from rename, as
    they may all share a single MAC for the bond device. (LP: #1802322)
  * tests/integration.py: add test designed to catch the above regression.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 21 Nov 2018 14:42:59 -0500

netplan.io (0.40.1~18.04.2) bionic; urgency=medium

  * Fix typo breaking rename on 'netplan apply'. (LP: #1770082)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 22 Oct 2018 15:02:30 -0400

netplan.io (0.40.1~18.04.1) bionic; urgency=medium

  * Backport netplan 0.40.1 to 18.04. (LP: #1793309)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 04 Oct 2018 13:59:42 -0400

netplan.io (0.40.1) cosmic; urgency=medium

  * tests/generate.py: use random.sample() instead of random.choices() to
    better support older pythons.
  * Deal gracefully with empty files on 'netplan apply' (LP: #1795343)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 04 Oct 2018 12:05:49 -0400

netplan.io (0.40) cosmic; urgency=medium

  * New upstream release:
    - networkd: route source is PreferredSource= not From=
    - Improve NetworkManager error reporting on unrenderable routes.
    - Don't render ipv4 dns-search unless we have an ipv4 address.
      (LP: #1786726)
    - Set permissive umask on networkd .network, .link and .netdev files
      (LP: #1736965, LP: #1768560)
    - Fix support for link-scope routes. (LP: #1747455)
    - Update man pages for deletion of replug code.
    - Spell Gratuitous ARP correctly and make it work. (LP: #1756701)
    - Many typo fixes for documentation. (LP: #1783940)
    - Various build system fixes.
    - Fix integration tests:
      - iproute2 output changes for link-scope routes
      - fix stability of networkd igmp-resend test
      - fix manual_addresses test now that networkd lists ~. domain
    - Deduplicate code for parsing interface options
    - Add support for optional-addresses.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 13 Sep 2018 17:29:41 -0400

netplan.io (0.39) cosmic; urgency=medium

  * New upstream release:
    - Allow link-local addresses to be configured. (LP: #1771704)
    - Forces bridges with no addresses to be brought online. (LP: #1736975)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 16 Jul 2018 08:15:05 -0400

netplan.io (0.38) cosmic; urgency=medium

  * New upstream release:
    - Write udev .rules files to /run/udev/rules.d to enforce interface
      renaming. (LP: #1770082)
    - Don't traceback for 'netplan ip leases' when iface is not managed or
      doesn't DHCP (LP: #1768823)
    - Fix duplicate "/" path separator in error messages (LP: #1771440)
    - Fix incorrect terminal reset in 'netplan try' on Ctrl-C. (LP: #1768798)
    - Updated doc entries: mtu, fix fwmark->mark, cleanup optional.
      (LP: #1768783)
    - Added documentation validation at build.
    - Added configuration example for multi-ip interfaces.
  * tests/integration.py: fix test_eth_and_bridge autopkg test harder.
  * debian/control:
    - Add iproute2 to Depends.
    - Add python3-netifaces to Depends, Build-Depends.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 04 Jun 2018 14:45:26 -0400

netplan.io (0.37.1) cosmic; urgency=medium

  * tests/integration.py: fix autopkgtests to be less flaky, especially given
    changes in systemd-networkd's behavior regarding Router Advertisements.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 11 May 2018 09:58:19 -0400

netplan.io (0.37) cosmic; urgency=medium

  * doc/netplan.md: Clarify the behavior for time-based values for bonds
    and bridges. (LP: #1756587)
  * critical: provide a way to set "CriticalConnection=true" on a networkd
    connection, especially for remote-fs scenarios. (LP: #1769682)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 08 May 2018 17:02:26 -0400

## netplan.io 0.40.2

=== debian/changelog ===
netplan.io (0.40.2) cosmic; urgency=medium

  * tests/integration.py: Mark regexes with r to pacify pycodestyle's W605.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 04 Oct 2018 16:02:53 -0400

## netplan.io 0.95

=== Makefile ===
--- 
+++ 
@@ -22,6 +22,7 @@
 # Order: Fedora/Mageia/openSUSE || Debian/Ubuntu || null
 PYFLAKES3 ?= $(shell which pyflakes-3 || which pyflakes3 || echo true)
 PYCODESTYLE3 ?= $(shell which pycodestyle-3 || which pycodestyle || which pep8 || echo true)
+NOSETESTS3 ?= $(shell which nosetests-3 || which nosetests3 || echo true)
 
 default: generate doc/netplan.html doc/netplan.5 doc/netplan-generate.8 doc/netplan-apply.8 doc/netplan-try.8
 
@@ -34,9 +35,8 @@
 	rm -rf test-coverage .coverage
 
 check: default linting
-	tests/generate.py
 	tests/cli.py
-	nosetests3 -v --with-coverage
+	$(NOSETESTS3) -v --with-coverage
 	tests/validate_docs.sh
 
 linting:

=== debian/changelog ===
netplan.io (0.95-2) unstable; urgency=medium

  * Set Priority to optional (Closes: #920327).

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 24 Jan 2019 09:43:13 +0100

netplan.io (0.95-1) unstable; urgency=medium

  * New upstream release.
  * Update autopkgtests from the upstream.
  * Add debian/watch following GitHub releases.
  * Add Homepage (Closes: #917233).

 -- Andrej Shadura <andrewsh@debian.org>  Sat, 29 Dec 2018 16:34:23 +0100

netplan.io (0.40.2-1) unstable; urgency=medium

  * Upload to Debian (Closes: #882661).

 -- Andrej Shadura <andrewsh@debian.org>  Wed, 14 Nov 2018 16:29:42 -0800

=== debian/control ===
Source: netplan.io
Maintainer: Debian netplan Maintainers <team+netplan@tracker.debian.org>
Uploaders:
 Andrej Shadura <andrewsh@debian.org>,
 Mathieu Trudel-Lapierre <mathieu.trudel-lapierre@canonical.com>
Section: net
Priority: optional
Standards-Version: 4.1.3
Build-Depends: debhelper (>= 11),
 pkg-config,
 bash-completion,
 libyaml-dev,
 libglib2.0-dev,
 uuid-dev,
 python3 (>= 3.1),
 python3-coverage,
 python3-yaml,
 python3-netifaces,
 systemd,
 pyflakes3,
 pycodestyle | pep8,
 python3-nose,
 pandoc,
Vcs-Git: https://salsa.debian.org/debian/netplan.io.git
Vcs-Browser: https://salsa.debian.org/debian/netplan.io
Homepage: https://netplan.io/

Package: netplan.io
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
 ${misc:Depends},
 iproute2,
 python3,
 python3-yaml,
 python3-netifaces,
 systemd (>= 239~),
Suggests: network-manager | wpasupplicant
Conflicts: netplan
Breaks: nplan (<< 0.34~), network-manager (<< 1.2.2-1)
Replaces: nplan (<< 0.34~)
Provides: nplan
Description: YAML network configuration abstraction for various backends
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 Currently supported backends are networkd and NetworkManager.

=== debian/tests/control ===
Test-Command: python3 tests/integration/run.py --test=ethernets
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=ethernets

Test-Command: python3 tests/integration/run.py --test=bridges
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=bridges

Test-Command: python3 tests/integration/run.py --test=bonds
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=bonds

Test-Command: python3 tests/integration/run.py --test=routing
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=routing

Test-Command: python3 tests/integration/run.py --test=vlans
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=vlans

Test-Command: python3 tests/integration/run.py --test=wifi
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=wifi

Test-Command: python3 tests/integration/run.py --test=tunnels
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=tunnels

Test-Command: python3 tests/integration/run.py --test=scenarios
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=scenarios

Test-Command: python3 tests/integration/run.py --test=regressions
Tests-Directory: tests/integration
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: allow-stderr, needs-root, isolation-machine
Features: test-name=regressions

Tests: autostart
Restrictions: allow-stderr, needs-root, isolation-container

## netplan.io 0.96

=== debian/changelog ===
netplan.io (0.96-0ubuntu4) disco; urgency=medium

  * d/p/0001-Partially-revert-the-change-for-enabling-systemd-net.patch:
    Also update tests to account for moving the systemd-networkd.service
    link.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 28 Mar 2019 15:15:13 -0400

netplan.io (0.96-0ubuntu3) disco; urgency=medium

  * d/p/0001-Partially-revert-the-change-for-enabling-systemd-net.patch:
    Partially revert changes to networkd jobs ordering: leave systemd-networkd
    enabled in multi-user.target instead of network-online.target, as in some
    minimal setups there might be no job requiring network-online.target,
    whereas the natural target to reach for booting is multi-user.target.
    (LP: #1821867)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 28 Mar 2019 13:53:40 -0400

netplan.io (0.96-0ubuntu2) disco; urgency=medium

  * d/p/0001-Automatically-skip-tests-when-wifi-is-clearly-unavai.patch:
    Update wifi tests to try to make them more reliable.
  * debian/tests/control: explicilty mark wifi tests flaky.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 14 Mar 2019 14:11:47 -0400

netplan.io (0.96-0ubuntu1) disco; urgency=medium

  * New upstream release 0.96.
    - Moved netplan-wpa@ services to earlier at boot (LP: #1819014)
    - Restart services when unconfiguring (LP: #1811868)
    - Use the .nmconnection extension for NM keyfiles (LP: #1817655)
    - Fixed integration tests runner to correctly report failures
    - Enforce integrity for use-routes in networkd backend.
    - Ensure terminal state at end of test (LP: #1817660)
    - Various small test fixes.
    - Fix typos in documentation.
  * debian/control: Update Maintainer for ubuntu upload.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 07 Mar 2019 14:00:26 -0500

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: netplan.io
-Maintainer: Debian netplan Maintainers <team+netplan@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian netplan Maintainers <team+netplan@tracker.debian.org>
 Uploaders:
  Andrej Shadura <andrewsh@debian.org>,
  Mathieu Trudel-Lapierre <mathieu.trudel-lapierre@canonical.com>

## netplan.io 0.97

=== Makefile ===
--- 
+++ 
@@ -26,7 +26,7 @@
 
 default: generate doc/netplan.html doc/netplan.5 doc/netplan-generate.8 doc/netplan-apply.8 doc/netplan-try.8
 
-generate: src/generate.[hc] src/parse.[hc] src/util.[hc] src/networkd.[hc] src/nm.[hc]
+generate: src/generate.[hc] src/parse.[hc] src/util.[hc] src/networkd.[hc] src/nm.[hc] src/validation.[hc] src/error.[hc]
 	$(CC) $(BUILDFLAGS) $(CFLAGS) -o $@ $(filter %.c, $^) `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
 
 clean:
@@ -73,8 +73,8 @@
 	install -m 755 generate $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/
 	find netplan/ -name '*.py' -exec install -Dm 644 "{}" "$(DESTDIR)/$(DATADIR)/netplan/{}" \;
 	install -m 755 src/netplan.script $(DESTDIR)/$(DATADIR)/netplan/
-	ln -sr $(DESTDIR)/$(DATADIR)/netplan/netplan.script $(DESTDIR)/$(SBINDIR)/netplan
-	ln -sr $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/generate $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR)/netplan
+	ln -srf $(DESTDIR)/$(DATADIR)/netplan/netplan.script $(DESTDIR)/$(SBINDIR)/netplan
+	ln -srf $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/generate $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR)/netplan
 	install -m 644 doc/*.html $(DESTDIR)/$(DOCDIR)/netplan/
 	install -m 644 examples/*.yaml $(DESTDIR)/$(DOCDIR)/netplan/examples/
 	install -m 644 doc/*.5 $(DESTDIR)/$(MANDIR)/man5/

=== debian/changelog ===
netplan.io (0.97-0ubuntu1~18.10.1) cosmic; urgency=medium

  * Backport netplan.io 0.97 to 18.10. (LP: #1828299)
  * Keep debian/patches/glib_changes.patch: Make sure tests work on older GLib.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 09 May 2019 11:29:56 -0400

netplan.io (0.97-0ubuntu1) eoan; urgency=medium

  * New upstream release: 0.97
    - networkd: force bringing up devices with no IP addresses (LP: #1763608)
    - Reworked renderer choosing to avoid regression in default renderer when
      multiple files specify it globally (LP: #1825206)
    - Fixed networkd activation. (LP: #1821867)
  * Drop all patches; they are included in the upstream release.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 08 May 2019 16:50:13 -0400

netplan.io (0.96-0ubuntu0.18.10.3) cosmic; urgency=medium

  * debian/patches/git_revert_explicit_renderer_def_ebc212a.patch: revert
    commit ebc212a: make renderer values explicit at the end of each parsing
    pass; it breaks "default" renderer behavior when multiple files may set
    a global renderer and expect the last to take effect globally.
    (LP: #1825206)
  * debian/patches/git_reorg_netdef_validation_181b583.patch: correct the
    fallout from the above change: validate netdefs in a single pass at the
    very end of parsing, once we know which is the applicable renderer. This
    makes sure tunnels get validated correctly.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 26 Apr 2019 15:19:19 -0400

netplan.io (0.96-0ubuntu0.18.10.2) cosmic; urgency=medium

  * d/p/0001-Partially-revert-the-change-for-enabling-systemd-net.patch:
    Partially revert changes to networkd jobs ordering: leave systemd-networkd
    enabled in multi-user.target instead of network-online.target, as in some
    minimal setups there might be no job requiring network-online.target,
    whereas the natural target to reach for booting is multi-user.target.
    (LP: #1821867)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 28 Mar 2019 13:57:46 -0400

netplan.io (0.96-0ubuntu0.18.10.1) cosmic; urgency=medium

  * Backport netplan.io 0.96 to 18.10.
  * debian/patches/glib_changes.patch: Patch tests to work again on older GLib.
  * debian/control: adjust Depends for cosmic / re-add nplan package.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 07 Mar 2019 16:49:19 -0500

netplan.io (0.95) disco; urgency=medium

  * New upstream release:
    - Added support for WPA Enterprise / 802.1x authentication (LP: #1739578)
    - Added support for setting up IP tunnels; supporting the types: ipip,
      gretap, VTI, ISATAP (NetworkManager only), sit, gre, ipip6 and ip6ip6.
      + Fixes sit (ipv6) tunnels using Hurricane Electric (LP: #1799487)
    - Add support to override networkd UseMTU setting (LP: #1807273)
    - Generate output files in dependency order
    - Refactored unit and integration tests, along with various cleanups.
    - Add DHCP overrides to control route usage and default metric for DHCP
      routes. (LP: #1776228)
    - Mitigate against bad matching on devices behind bonds then they share
      the same MAC from a physical interface. (LP: #1804861)
    - Added snapcraft.yaml.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 14 Dec 2018 16:04:05 -0500

netplan.io (0.90.1) disco; urgency=medium

  * Do not assume /etc/network exists in postinst, as netbase 5.5 no longer
    creates it.
  * netplan/cli/commands/ip.py: fix a flake.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 26 Nov 2018 10:59:38 +1300

netplan.io (0.90) disco; urgency=medium

  * New upstream release:
    - build: fixes for building on RPM-based distros
    - build: code prettiness changes (make indentation consistent)
    - Fix device name-changes detection (LP: #1770082)
    - Add support for IPv6 Privacy Extensions (LP: #1750392)
    - Add dhcp{4,6}-overrides to control DNS, NTP, hostname updates via DHCP
      (LP: #1759014)
    - Clarify MAC and MTU setting requirements (LP: #1800668)
    - Various documentation fixes (LP: #1800669)
    - Improve error reporting to give clearer messages and context
      (LP: #1800670)
    - Skip non-physical/bond interfaces when applying renames (LP: #1802322)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 21 Nov 2018 14:06:13 -0500

=== debian/control ===
--- 
+++ 
@@ -35,10 +35,10 @@
  python3,
  python3-yaml,
  python3-netifaces,
- systemd (>= 239~),
+ systemd (>= 235-3ubuntu3),
 Suggests: network-manager | wpasupplicant
 Conflicts: netplan
-Breaks: nplan (<< 0.34~), network-manager (<< 1.2.2-1)
+Breaks: nplan (<< 0.34~), network-manager (<< 1.2.2-0ubuntu4~)
 Replaces: nplan (<< 0.34~)
 Provides: nplan
 Description: YAML network configuration abstraction for various backends
@@ -49,3 +49,17 @@
  networking daemon.
  .
  Currently supported backends are networkd and NetworkManager.
+
+Package: nplan
+Architecture: all
+Priority: optional
+Section: oldlibs
+Depends: netplan.io, ${misc:Depends}
+Description: YAML network configuration abstraction - transitional package
+ netplan reads YAML network configuration files which are written
+ by administrators, installers, cloud image instantiations, or other OS
+ deployments. During early boot it then generates backend specific
+ configuration files in /run to hand off control of devices to a particular
+ networking daemon.
+ .
+ This is a transitional package that installs 'netplan.io'.

## netplan.io 0.98

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 BUILDFLAGS = \
 	-std=c99 \
 	-D_XOPEN_SOURCE=500 \
+	-DSBINDIR=\"$(SBINDIR)\" \
 	-Wall \
 	-Werror \
 	$(NULL)
@@ -9,28 +10,46 @@
 SYSTEMD_UNIT_DIR=$(shell pkg-config --variable=systemdsystemunitdir systemd)
 BASH_COMPLETIONS_DIR=$(shell pkg-config --variable=completionsdir bash-completion || echo "/etc/bash_completion.d")
 
-ROOTPREFIX ?= /
+GCOV ?= gcov
+ROOTPREFIX ?=
 PREFIX ?= /usr
 ROOTLIBEXECDIR ?= $(ROOTPREFIX)/lib
+LIBEXECDIR ?= $(PREFIX)/lib
 SBINDIR ?= $(PREFIX)/sbin
 DATADIR ?= $(PREFIX)/share
 DOCDIR ?= $(DATADIR)/doc
 MANDIR ?= $(DATADIR)/man
 
-PYCODE = netplan/ $(wildcard src/*.py) $(wildcard tests/*.py)
+PYCODE = netplan/ $(wildcard src/*.py) $(wildcard tests/*.py) $(wildcard tests/generator/*.py) $(wildcard tests/dbus/*.py)
 
 # Order: Fedora/Mageia/openSUSE || Debian/Ubuntu || null
 PYFLAKES3 ?= $(shell which pyflakes-3 || which pyflakes3 || echo true)
 PYCODESTYLE3 ?= $(shell which pycodestyle-3 || which pycodestyle || which pep8 || echo true)
 NOSETESTS3 ?= $(shell which nosetests-3 || which nosetests3 || echo true)
 
-default: generate doc/netplan.html doc/netplan.5 doc/netplan-generate.8 doc/netplan-apply.8 doc/netplan-try.8
+default: netplan/_features.py generate netplan-dbus dbus/io.netplan.Netplan.service doc/netplan.html doc/netplan.5 doc/netplan-generate.8 doc/netplan-apply.8 doc/netplan-try.8
 
 generate: src/generate.[hc] src/parse.[hc] src/util.[hc] src/networkd.[hc] src/nm.[hc] src/validation.[hc] src/error.[hc]
-	$(CC) $(BUILDFLAGS) $(CFLAGS) -o $@ $(filter %.c, $^) `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
+	$(CC) $(BUILDFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(filter %.c, $^) `pkg-config --cflags --libs glib-2.0 gio-2.0 yaml-0.1 uuid`
+
+netplan-dbus: src/dbus.c src/_features.h
+	$(CC) $(BUILDFLAGS) $(CFLAGS) -o $@ $^ `pkg-config --cflags --libs libsystemd glib-2.0`
+
+src/_features.h: src/[^_]*.[hc]
+	echo "#include <stddef.h>\nstatic const char *feature_flags[] __attribute__((__unused__)) = {" > $@
+	awk 'match ($$0, /netplan-feature:.*/ ) { $$0=substr($$0, RSTART, RLENGTH); print "\""$$2"\"," }' $^ >> $@
+	echo "NULL, };" >> $@
+
+netplan/_features.py: src/[^_]*.[hc]
+	echo "# Generated file" > $@
+	echo "NETPLAN_FEATURE_FLAGS = [" >> $@
+	awk 'match ($$0, /netplan-feature:.*/ ) { $$0=substr($$0, RSTART, RLENGTH); print "    \""$$2"\"," }' $^ >> $@
+	echo "]" >> $@
 
 clean:
+	rm -f netplan/_features.py src/_features.h
 	rm -f generate doc/*.html doc/*.[1-9]
+	rm -f netplan-dbus dbus/*.service
 	rm -f *.gcda *.gcno generate.info
 	rm -rf test-coverage .coverage
 
@@ -57,7 +76,7 @@
 	python3-coverage report --omit=/usr* --show-missing --fail-under=100
 
 c-coverage:
-	lcov --directory . --capture -o generate.info
+	lcov --directory . --capture --gcov-tool=$(GCOV) -o generate.info
 	lcov --remove generate.info "/usr*" -o generate.info
 	genhtml -o test-coverage/C/ -t "generate test coverage" generate.info
 
@@ -81,6 +100,15 @@
 	install -m 644 doc/*.8 $(DESTDIR)/$(MANDIR)/man8/
 	install -D -m 644 src/netplan-wpa@.service $(DESTDIR)/$(SYSTEMD_UNIT_DIR)/netplan-wpa@.service
 	install -T -D -m 644 netplan.completions $(DESTDIR)/$(BASH_COMPLETIONS_DIR)/netplan
+	# dbus
+	mkdir -p $(DESTDIR)/$(DATADIR)/dbus-1/system.d $(DESTDIR)/$(DATADIR)/dbus-1/system-services
+	install -m 755 netplan-dbus $(DESTDIR)/$(ROOTLIBEXECDIR)/netplan/
+	install -m 644 dbus/io.netplan.Netplan.conf $(DESTDIR)/$(DATADIR)/dbus-1/system.d/
+	install -m 644 dbus/io.netplan.Netplan.service $(DESTDIR)/$(DATADIR)/dbus-1/system-services/
+
+%.service: %.service.in
+	sed -e "s#@ROOTLIBEXECDIR@#$(ROOTLIBEXECDIR)#" $< > $@
+
 
 %.html: %.md
 	pandoc -s --toc -o $@ $<

=== debian/changelog ===
netplan.io (0.98-2) unstable; urgency=medium

  * Cherry-pick upstream commits.
  * Use debhelper-compat instead of debian/compat.
  * Bump debhelper from old 11 to 12.
  * Bump Standards-Version to 4.4.1 (no changes).

 -- Andrej Shadura <andrewsh@debian.org>  Fri, 01 Nov 2019 15:21:21 +0100

netplan.io (0.98-1) unstable; urgency=medium

  [ Andrej Shadura ]
  * New upstream release: 0.98 (LP: #1840832).
  * Run all autopkgtests with Restriction: isolation-machine (Closes:
    #919426).

  [ Mathieu Trudel-Lapierre ]
  * debian/control: Add Build-Depends on libsystemd-dev for the D-Bus feature,
    and on dbus-x11 for dbus-launch used in tests.

 -- Andrej Shadura <andrewsh@debian.org>  Thu, 26 Sep 2019 14:35:32 +0200

=== debian/control ===
Source: netplan.io
Maintainer: Debian netplan Maintainers <team+netplan@tracker.debian.org>
Uploaders:
 Andrej Shadura <andrewsh@debian.org>,
 Mathieu Trudel-Lapierre <mathieu.trudel-lapierre@canonical.com>
Section: net
Priority: optional
Standards-Version: 4.4.1
Build-Depends: debhelper-compat (= 12),
 pkg-config,
 bash-completion,
 libyaml-dev,
 libglib2.0-dev,
 uuid-dev,
 python3 (>= 3.1),
 python3-coverage,
 python3-yaml,
 python3-netifaces,
 libsystemd-dev,
 systemd,
 dbus-x11,
 pyflakes3,
 pycodestyle | pep8,
 python3-nose,
 pandoc,
Vcs-Git: https://salsa.debian.org/debian/netplan.io.git
Vcs-Browser: https://salsa.debian.org/debian/netplan.io
Homepage: https://netplan.io/

Package: netplan.io
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
 ${misc:Depends},
 iproute2,
 python3,
 python3-yaml,
 python3-netifaces,
 systemd (>= 239~),
Suggests: network-manager | wpasupplicant
Conflicts: netplan
Breaks: nplan (<< 0.34~), network-manager (<< 1.2.2-1)
Replaces: nplan (<< 0.34~)
Provides: nplan
Description: YAML network configuration abstraction for various backends
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 Currently supported backends are networkd and NetworkManager.

=== debian/tests/control ===
--- 
+++ 
@@ -55,7 +55,7 @@
   network-manager,
   hostapd,
   dnsmasq-base,
-Restrictions: allow-stderr, needs-root, isolation-machine
+Restrictions: allow-stderr, needs-root, isolation-machine, flaky
 Features: test-name=wifi
 
 Test-Command: python3 tests/integration/run.py --test=tunnels
@@ -89,4 +89,4 @@
 Features: test-name=regressions
 
 Tests: autostart
-Restrictions: allow-stderr, needs-root, isolation-container
+Restrictions: allow-stderr, needs-root, isolation-machine
